'FFSubmenu=Exif
'FFName=Exif_Reparatur


'(c) Harald Maeckler, Dsseldorf 2017 - 2019
' ***********************************************************************
' Exif_Reparatur.vbs (Skript fr FixFoto)
' Reparieren und Reduzieren von Exif-Daten
' ***********************************************************************
'
' Version 1.02 vom 16.03.2019	- Beschreibung berarbeitet
'								- Update-Funktion hinzugefgt
' Version 1.01 vom 19.07.2017	- Kennzeichnung einer Reduzierung in 'Software'
' Version 1.00 vom 13.07.2017	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.02"
const SkriptURL = "https://www.ffsf.de/resources/ordnersuche.360/"	'###
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim n,pos,element,Abbruch,Antwort
Dim flag_Anzeigen : flag_Anzeigen = false

'Spezifische Konstanten und Variable
Dim Auswahl,BildName,bild_array,ArrayExifName,ArrayExifTags,ExifDaten
Dim flag_Kennung,Kennung
const ExifName = "Aufnahmedatum|Weiabgleich|Lichtquelle|Belichtungszeit|Blende|Korrektur|Brennweite|ISO|Blitz|Kamera|Hersteller|Belichtungspr.|Messmethode|Fotograf|Copyrigh1|Copyright2|Beschreibung|Kommentar|Software|Latitude|Longitude|Altitude"
const ExifTags = "DateTimeOriginal|WhiteBalance|LightSource|ExposureTime|FNumber|ExposureBiasValue|FocalLength|ISOSpeedRatings|Flash|Model|Make|ExposureProgram|MeteringMode|Artist|Copyright1|Copyright2|ImageDescription|UserComment|Software|Latitude|Longitude|Altitude"

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Exif_Reparatur"					'Skriptname
const RegSchluessel = "FF_Exif_Reparatur"		'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Exif_Reparatur **
FF_AddDialog "Exif_Reparatur",196,85
FF_AddControl "Exif_Reparatur","Auswahl","GROUP",40,5,110,25
FF_AddControl "Exif_Reparatur","Bilderauswahl","COMBO",45,15,100,10
FF_AddControl "Exif_Reparatur","flag_Kennung","BOOL",17,35,8,8
FF_AddControl "Exif_Reparatur","Kennzeichnung der reduzierten Daten in 'Software' mit ","STATIC",30,34,134,10
FF_AddControl "Exif_Reparatur","Kennung","SLEDIT",163,34,15,10
FF_SetControlStyle "Exif_Reparatur","Kennung",1
FF_AddControl "Exif_Reparatur","Die Exif-Daten werden reduziert auf die in FF anzeigbaren Bildinformationen","STATIC",5,46,186,10
FF_SetControlStyle "Exif_Reparatur","Die Exif-Daten werden reduziert auf die in FF anzeigbaren Bildinformationen",1
FF_AddControl "Exif_Reparatur","Fortschritt","PROGRESS",5,60,186,4
FF_AddControl "Exif_Reparatur","?","BUTTON",5,70,11,11
FF_AddControl "Exif_Reparatur","|","STATIC",19,70,22,11
FF_SetControlStyle "Exif_Reparatur","|",1
FF_AddControl "Exif_Reparatur","Abbrechen","BUTTON",87,70,33,11
FF_AddControl "Exif_Reparatur","Anzeigen","BUTTON",123,70,33,11
FF_AddControl "Exif_Reparatur","Reduzieren","BUTTON",158,70,33,11
FF_AddControl "Exif_Reparatur","&delete","BUTTON",0,0,1,1
FF_AddControl "Exif_Reparatur","Update","BUTTON",43,70,33,11
'** End Dialog Exif_Reparatur **
'FF_AddControl "Exif_Reparatur","Update","BUTTON",42,56,33,11

FF_SetControl "Exif_Reparatur","Bilderauswahl","alle Bilder der Computeransicht"		'Auswahl 0
FF_SetControl "Exif_Reparatur","Bilderauswahl","selekt. Bilder der Computeransicht"		'Auswahl 1
FF_SetControl "Exif_Reparatur","Bilderauswahl","alle Bilder der Bilderliste"			'Auswahl 2
FF_SetControl "Exif_Reparatur","Bilderauswahl","selektierte Bilder der Bilderliste"		'Auswahl 3

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Exif_Reparatur","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Exif_Reparatur","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Exif_Reparatur","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "Exif_Reparatur","Anzeigen", "" &_
						 "Exif-Daten markierter Bilder" & vbNewline &_
						 "nacheinander anzeigen"
	FF_SetControlTooltip "Exif_Reparatur","Reduzieren", "" &_
						 "bei markierten Bildern" & vbNewLine &_
						 "die Exif-Daten reduzieren"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 3500
FF_SetDialogTimer "Exif_Reparatur", 100
FF_ActivateControl "Exif_Reparatur","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("Exif_Reparatur")
	Case "TIMER"
		FF_SetDialogTimer "Exif_Reparatur", 0
		FF_SetControl "Exif_Reparatur" ,"|", "V " & Skriptversion
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		'FF_SetControl "Exif_Reparatur","Fortschritt",65	'############## nur fr Screenshot
		WshShell.Popup "" & _
			"Reduzieren" & vbNewLine &_
			"---------------" & vbNewLine &_
			"Wird ein Exif-Datenfehler gemeldet, z.B. 'Exif data block too"  & vbNewLine &_
			"large', kann man mit Reduzieren versuchen den Fehler zu" & vbNewLine &_
			"beheben. Dazu werden die in FixFoto anzeigbaren Bildin-" & vbNewLine &_
			"formationen ausgelesen, der Exif-Datenblock gelscht," & vbNewLine &_
			"ein neuer erstellt und die Exif-Daten wieder eingetragen." & vbNewLine & vbNewLine &_
			"Zur Kennzeichnung, dass die Daten reduziert wurden, kann" & vbNewLine &_
			"in der Date 'Software' eine Kennung angehngt werden." & vbNewLine & vbNewLine &_
			"Anzeigen" & vbNewLine &_
			"------------" & vbNewLine &_
			"Man kann sich die Exif-Daten der ausgewhlten Bilder nach-" & vbNewLine &_
			"einander ansehen ohne das sie reduziert werden." & vbNewLine & vbNewLine &_
			"Skript lschen" & vbNewLine &_
			"------------------" & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das" & vbNewLine &_
			"Skript eine Lschroutine aufgerufen werden." & vbNewLine & vbNewLine &_
			"Copyright Harald Maeckler" & vbNewLine & vbNewLine &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Abbrechen","CANCEL"
		exit do
	Case "Anzeigen"
		flag_Anzeigen = true
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			flag_Anzeigen = false
		end if
	Case "Reduzieren"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			exit do
		end if
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Exif_Reparatur")
if SkriptKill then
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Schleife

Dim bilder,Anz,AnzB,n

bilder = FF_GetSelection(Auswahl)
if len(bilder) = 0 then
	msgbox "Im Computerverzeichnis sind keine Bilder markiert!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

bild_array = split(bilder,vbNewline)
Anz = ubound(bild_Array) +1 : AnzB = 0
For n = 0 to Anz -1
	FF_LoadImage bild_Array(n)
	if FF_HasExif then
		call ExifErmittlung
		if flag_Anzeigen then
			BildName = objFS.GetFileName(bild_Array(n))
			call ExifAnzeige
			AnzB = AnzB +1
			if Abbruch then exit for
		else
			FF_KillExif()
			FF_CreateExif()
			FF_SaveExif(bild_Array(n))
			call ExifEintrag
			FF_SaveExif(bild_Array(n))
			AnzB = AnzB +1
		end if
	end if

	'### Fortschrittsanzeige
	FF_SetControl "Exif_Reparatur","Fortschritt",(n +1)/Anz*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
next

if flag_Anzeigen then
		msgbox "Von " & Anz & " Bildern wurden von " & AnzB & vbNewline &_
				"die Exif-Daten angezeigt.",vbInformation,"Schlussmeldung"
else
	if Anz > AnzB then
		msgbox "Von " & Anz & " Bildern wurden " & AnzB & " bearbeitet." & vbNewline &_
				Anz - AnzB & " Bilder haben keine Exif-Daten.",vbInformation,"Schlussmeldung"
	else
		msgbox "Es wurden alle " & AnzB & " Bilder berabeitet!",vbInformation,"Schlussmeldung"
	end if
end if

FF_SetControl "Exif_Reparatur","Fortschritt",0

End Sub
'------------------------------------------------------------------------
Sub ExifErmittlung
Dim Date

ArrayExifTags = split(ExifTags,"|")

Date = trim(FF_GetExifTag(ArrayExifTags(0)))
ExifDaten = Date

for n = 1 to 4
	Date = trim(FF_GetExifTagAdvanced(ArrayExifTags(n)))
	ExifDaten = ExifDaten & "|" & Date
next

for n = 5 to ubound(ArrayExifTags)
	Date = trim(FF_GetExifTag(ArrayExifTags(n)))
	ExifDaten = ExifDaten & "|" & Date
next

End Sub
'------------------------------------------------------------------------
Sub ExifEintrag
Dim ArrayExifDate

ArrayExifDate = split(ExifDaten,"|")
for n = 0 to ubound(ArrayExifTags)
	if ArrayExifTags(n) = "Software" then ArrayExifDate(n) = ArrayExifDate(n) & "*"
	FF_SetExifTag ArrayExifTags(n),ArrayExifDate(n)
next

End Sub
'------------------------------------------------------------------------
Sub ExifAnzeige
Dim ExifAnzeige,ArrayExifDate

ArrayExifName = split(ExifName,"|")
ArrayExifDate = split(ExifDaten,"|")
for n = 0 to ubound(ArrayExifName)
	if n = 0 then
		ExifAnzeige = ArrayExifName(0) & " = " & ArrayExifDate(0)
	else
		ExifAnzeige = ExifAnzeige & vbNewline & ArrayExifName(n) & " = " & ArrayExifDate(n)
	end if
next

Antwort = msgbox("Bild " & BildName &_
					vbNewLine & vbNewLine & ExifAnzeige,vbOKCancel,"Exif-Daten")
if Antwort = vbCancel then Abbruch = true

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen
Dim AuswahlWert

'Auswahl
'0 = alle Bilder der Computeransicht
'1 = selekt. Bilder der Computeransicht
'2 = alle Bilder der Bilderliste
'3 = selektierte Bilder der Bilderliste

AuswahlWert = FF_GetControl("Exif_Reparatur","Bilderauswahl")
select case AuswahlWert
	case "alle Bilder der Computeransicht"		Auswahl = 0
	case "selekt. Bilder der Computeransicht"	Auswahl = 1
	case "alle Bilder der Bilderliste"			Auswahl = 2
	case "selektierte Bilder der Bilderliste"	Auswahl = 3
case else
	msgbox "Ungltige Auswahl!"
end select

flag_Kennung = FF_GetControl("Exif_Reparatur","flag_Kennung")
Kennung = FF_GetControl("Exif_Reparatur","Kennung")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if flag_Kennung = 1 and len(trim(Kennung)) = 0 then
	msgbox "Es fehlt ein Kennzeichnungstext!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 1

flag_Kennung = FF_GetProfile (RegSchluessel,"flag_Kennung")
if flag_Kennung = "" then flag_Kennung = 1
Kennung = FF_GetProfile (RegSchluessel,"Kennung")
if Kennung = "" then Kennung = " *"

'### Werte eintragen

'Auswahl
select case Auswahl
	case 0
	FF_SetControl "Exif_Reparatur","Bilderauswahl","alle Bilder der Computeransicht"
	case 1
	FF_SetControl "Exif_Reparatur","Bilderauswahl","selekt. Bilder der Computeransicht"
	case 2
	FF_SetControl "Exif_Reparatur","Bilderauswahl","alle Bilder der Bilderliste"
	case 3
	FF_SetControl "Exif_Reparatur","Bilderauswahl","selektierte Bilder der Bilderliste"
end select

FF_SetControl "Exif_Reparatur","flag_Kennung",flag_Kennung
FF_SetControl "Exif_Reparatur","Kennung",Kennung

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl
FF_WriteProfile RegSchluessel,"flag_Kennung",flag_Kennung
FF_WriteProfile RegSchluessel,"Kennung",Kennung

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
